<?php

  class payer {
    var $code, $title, $description, $enabled;
    
    function payer() {
      global $order;
      
      $this->code = 'payer';
      
      $this->moduleinfo = array(
        'name'        => 'Payer Sweden AB',
        'description' => 'Den hr modulen lter dig erbjuda Payers betalningsmetoder som betalningsalternativ. Modulen r omskriven av TiM-International.net fr kad kompatibilitet med osCommerce.',
        'changelog'   => array(
          //'200X-XX-XX' => '*/+/- Din changelog text.',
          '2009-09-05' => '+ Std fr ikoner. // Tim',
          '2008-10-15' => '+ Meddelande om sker verfring fr order_confirmation.php. // Tim',
          '2008-10-15' => '+ Std fr egen titel och beskrivning fr metodval i sprkfilen. // Tim',
          '2008-08-25' => '* Momskalkylen returnerade felaktig moms. // Tim',
          '2008-08-24' => '+ Modul skapad. // Tim',
        ),
        'author'      => 'T. Almroth',
        'platform'    => 'osCommerce 2.2',
        'homepage'    => 'http://www.tim-international.net',
        'support'     => 'http://www.oscforum.se',
      );
      
      if (basename($_SERVER['PHP_SELF']) == 'modules.php') {
        
        $this->title     = '[TiM\'s osC Modules] Version '. key($this->moduleinfo['changelog']) .' :: '. $this->moduleinfo['name'];
        
        $this->description = $this->moduleinfo['description'] . '
          <br><br>
          <script language="javascript">
          function changeloggg() {
            alert(\'* = ndrat\\\\n+ = Tillagt\\\n- = Borttaget\\\n\\\n' . implode('\\\n', array_reverse($this->moduleinfo['changelog'])) . '\')
          }
          </script>
          <table border="0" cellpadding="2" cellspacing="0" bgcolor="#F0F1F1" align="center">
            <tr class"dataTableHeadingRow">
              <td colspan="2" bgcolor="cecbce" class="dataTableHeadingContent" nowrap><strong>Om modulen</strong></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Modulnamn: </strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['name'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Skapad av: </strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['author'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Plattform:</strong></td>
              <td class="dataTableContent">'. $this->moduleinfo['platform'] .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Modulversion:</strong></td>
              <td class="dataTableContent">'. key($this->moduleinfo['changelog']) .'</td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>ndringslogg:</strong></td>
              <td class="dataTableContent"><a href="javascript:changeloggg();">&lt;Klicka f&ouml;r att se&gt;</a></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Programlnk: </strong></td>
              <td class="dataTableContent"><a href="'. $this->moduleinfo['homepage'] .'" target="_blank">'. substr($this->moduleinfo['homepage'], 0, 18) .'...</a></td>
            </tr>
            <tr class"dataTableRow">
              <td class="dataTableContent" nowrap><strong>Supportlnk:</strong></td>
              <td class="dataTableContent"><a href="'. $this->moduleinfo['support'] .'" target="_blank">'. substr($this->moduleinfo['support'], 0, 18) .'...</a></td>
            </tr>
          </table>';
      
      } else {
        
        $this->title     = $this->moduleinfo['name'];
      }
      
      $this->enabled = ((MODULE_PAYMENT_PAYER_MULTI_STATUS == 'Ja') ? true : false);
      $this->sort_order  = MODULE_PAYMENT_PAYER_MULTI_SORT_ORDER;
      $this->card_type = array(
        array('id' => '2', 'text' => 'VISA'),
        array('id' => '3', 'text' => 'MasterCard'),
        array('id' => '4', 'text' => 'Diners')
      );
      
      // Set defaults
      $this->myPostApiVersion  = 'payread_php_0_2';
      $this->form_action_url  = 'https://secure.pay-read.se/PostAPI_V1/InitPayFlow';
      $this->myLanguage    = 'sv';
      $this->myDebugMode    = 'silent';
      
      if ((int)MODULE_PAYMENT_PAYER_MULTI_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYER_MULTI_ORDER_STATUS_ID;
      }
      
      if (is_object($order)) $this->update_status();
    }
    
    // class methods
    function update_status() {
      global $order;
      
      if ($this->enabled == true && (int)MODULE_PAYMENT_PAYER_MULTI_ZONE > 0) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYER_MULTI_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }
        
        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }
    
    function javascript_validation() {
      return false;
    }
    
    function selection() {
      
      if (basename($_SERVER['PHP_SELF']) == 'checkout_payment.php') {
        return array(
          'id' => $this->code,
          'module' => ((MODULE_PAYMENT_PAYER_ICON != '') ? tep_image(MODULE_PAYMENT_PAYER_ICON, MODULE_PAYMENT_PAYER_TEXT_TITLE) : ((MODULE_PAYMENT_PAYER_MULTI_TESTMODE == 'Ja') ? '[Test mode] ' : false) . MODULE_PAYMENT_PAYER_TEXT_TITLE) . ((MODULE_PAYMENT_PAYER_TEXT_DESCRIPTION != '') ? '<br /><span style="font-weight: normal;">'. MODULE_PAYMENT_PAYER_TEXT_DESCRIPTION .'</span>' : false)
        );
      } else {
        return array(
          'id' => $this->code,
          'module' => MODULE_PAYMENT_PAYER_TEXT_TITLE
        );
      }
    }
    
    function pre_confirmation_check() {
      return false;
    }
    
    function confirmation() {
      return array(
        'title' => MODULE_PAYMENT_PAYER_TEXT_PRENOTICE
      );
    }
    
    function process_button() {
      global $order, $currencies, $customer_id;
      
      //$this->myDebugMode = 'verbose';
      $this->myTestMode = (MODULE_PAYMENT_PAYER_MULTI_TESTMODE=='Ja') ? 'true' : 'false';
      $this->myPaymentMethods[] = 'card';
      
      // Header
      $this->myXmlData  = '<?xml version="1.0" encoding="ISO-8859-1"?>'
                        . '<payread_post_api_0_2 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="payread_post_api_0_2.xsd">';
      
      // Seller details
      $this->myXmlData .= '  <seller_details>'
                         .'    <agent_id>'. htmlspecialchars(MODULE_PAYMENT_PAYER_MULTI_AGENT_ID) .'</agent_id>'
                         .'  </seller_details>';
      
      // Buyer details
      $this->myXmlData .= '  <buyer_details>'
                        . '    <first_name>'. htmlspecialchars($order->customer['firstname']) .'</first_name>'
                        . '    <last_name>'. htmlspecialchars($order->customer['lastname']) .'</last_name>'
                        . '    <address_line_1>'. htmlspecialchars($order->customer['street_address']) .'</address_line_1>'
                        . '    <address_line_2>'. htmlspecialchars($order->customer['suburb']) .'</address_line_2>'
                        . '    <postal_code>'. htmlspecialchars($order->customer['postcode']) .'</postal_code>'
                        . '    <city>'. htmlspecialchars($order->customer['city']) .'</city>'
                        . '    <country_code>'. htmlspecialchars($order->customer['country']['iso_code_2']) .'</country_code>'
                        . '    <phone_home>'. htmlspecialchars($order->customer['telephone']) .'</phone_home>'
                        . '    <phone_work></phone_work>'
                        . '    <phone_mobile></phone_mobile>'
                        . '    <email>'. $order->customer['email_address'] .'</email>'
                        . '  </buyer_details>';
      
      // Purchase
      $this->myXmlData .= '  <purchase>'
                        . '    <currency>'. ((isset($order->info['currency'])) ? $order->info['currency'] : 'SEK')  .'</currency>'
                        . '    <purchase_list>'
                        . '      <freeform_purchase>'
                        . '        <line_number>1</line_number>'
                        . '        <description>'. htmlentities(STORE_NAME . ' ('. HTTP_SERVER .')') .'</description>'
                        . '        <price_including_vat>'. tep_round($order->info['total'] * $currency_value, $currencies->currencies[$currency_code]['decimal_places']) .'</price_including_vat>'
                        . '        <vat_percentage>'. ($order->info['tax']/($order->info['total']-$order->info['tax'])*100) .'</vat_percentage>'
                        . '        <quantity>1</quantity>'
                        . '      </freeform_purchase>'
                        . '    </purchase_list>'
                        . '  </purchase>';
      
      //Processing control
      $this->myXmlData .= '  <processing_control>'
                        . '    <success_redirect_url>'      . htmlentities(tep_href_link(FILENAME_CHECKOUT_PROCESS))          . '</success_redirect_url>'
                        . '    <authorize_notification_url>'  . htmlentities(tep_href_link("ext/modules/payment/payer/authorize.php?id=1"))  . '</authorize_notification_url>'
                        . '    <settle_notification_url>'    . htmlentities(tep_href_link("ext/modules/payment/payer/settle.php?id=1"))    . '</settle_notification_url>'
                        . '    <redirect_back_to_shop_url>'   . htmlentities(tep_href_link("index.php"))                   . '</redirect_back_to_shop_url>'
                        . '  </processing_control>';
      
      // Database overrides
      $this->myXmlData .= '  <database_overrides>';
      
      // Payment methods
      $this->myXmlData .= '    <accepted_payment_methods>'
                        . ((MODULE_PAYMENT_PAYER_MULTI_CC_STATUS == 'Ja') ? '      <payment_method>card</payment_method>' : false)
                        . ((MODULE_PAYMENT_PAYER_MULTI_BANK_STATUS == 'Ja') ? '      <payment_method>bank</payment_method>' : false)
                        . ((MODULE_PAYMENT_PAYER_MULTI_INVOICE_STATUS == 'Ja') ? '      <payment_method>invoice</payment_method>' : false)
                        . ((MODULE_PAYMENT_PAYER_MULTI_PHONE_STATUS == 'Ja') ? '      <payment_method>invoice</payment_method>' : false)
                        . '    </accepted_payment_methods>';
      
      $this->myXmlData .= '    <debug_mode>'  . $this->myDebugMode  . '</debug_mode>' .
                          '    <test_mode>'  . $this->myTestMode    . '</test_mode>' .
                          '    <language>'    . $this->myLanguage    . '</language>' .
                          '  </database_overrides>' .
                          '</payread_post_api_0_2>';
      
      // Encrypt XML data
      $this->myXmlData = base64_encode($this->myXmlData);
      
      return tep_draw_hidden_field('payread_agentid', MODULE_PAYMENT_PAYER_MULTI_AGENT_ID)
        . tep_draw_hidden_field('payread_xml_writer', $this->myPostApiVersion)
        . tep_draw_hidden_field('payread_data', $this->myXmlData)
        . tep_draw_hidden_field('payread_checksum', md5(MODULE_PAYMENT_PAYER_MULTI_KEY_1 . $this->myXmlData . MODULE_PAYMENT_PAYER_MULTI_KEY_2));
      
    }
    
    function before_process() {
      return true;
    }
    
    function after_process() {
      return true;
    }
    
    function get_error() {
      global $HTTP_GET_VARS;
      
      $error = array(
        'title' => MODULE_PAYMENT_PAYER_MULTI_TEXT_ERROR,
        'error' => ((isset($HTTP_GET_VARS['error'])) ? stripslashes(urldecode($HTTP_GET_VARS['error'])) : "Default kortfel!")
      );
      
      return $error;
    }
    
    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYER_MULTI_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }
    
    function install() {
      $this->remove();
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Tjnsten aktiverad?', 'MODULE_PAYMENT_PAYER_MULTI_STATUS', 'Ja', 'Vill du erbjuda kortbetalning via Pay&Read?', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Ikon', 'MODULE_PAYMENT_PAYER_ICON', '', 'Om du vill visa en ikon istllet fr ett textalternativ, ange webbskvg ex. /images/myicon.gif', '6', '1', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Testlge', 'MODULE_PAYMENT_PAYER_MULTI_TESTMODE', 'Ja', 'Vill du anvnda testlge? (Inga riktiga kortdebiteringar grs)', '6', '2', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Agent ID', 'MODULE_PAYMENT_PAYER_MULTI_AGENT_ID', 'TESTINSTALLATION', 'Ange ditt Agent ID hos Payer.', '6', '3' , now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Nyckel 1', 'MODULE_PAYMENT_PAYER_MULTI_KEY_1', '00000000000000000000000000000000', 'Ange Nyckel 1 du erhllit frn Payer.', '6', '4' , now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Nyckel 2', 'MODULE_PAYMENT_PAYER_MULTI_KEY_2', '00000000000000000000000000000000', 'Ange Nyckel 2 du erhllit frn Payer.', '6', '5' , now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Kortbetalning?', 'MODULE_PAYMENT_PAYER_MULTI_CC_STATUS', 'Ja', 'Vill du erbjuda betalning via konto-/kreditkort?', '6', '6', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Internetbank?', 'MODULE_PAYMENT_PAYER_MULTI_BANK_STATUS', 'Ja', 'Vill du erbjuda betalning via internetbank?', '6', '7', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Faktura?', 'MODULE_PAYMENT_PAYER_MULTI_INVOICE_STATUS', 'Nej', 'Vill du erbjuda betalning via faktura?', '6', '8', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Telefonbetalning?', 'MODULE_PAYMENT_PAYER_MULTI_PHONE_STATUS', 'Nej', 'Vill du erbjuda betalning via telefon?', '6', '9', 'tep_cfg_select_option(array(\'Ja\', \'Nej\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Stt orderstatus', 'MODULE_PAYMENT_PAYER_MULTI_ORDER_STATUS_ID', '0', 'Byt till fljande status fr ordrar gjorda med det hr betalningsalternativet.', '6', '10', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sortering', 'MODULE_PAYMENT_PAYER_MULTI_SORT_ORDER', '0', 'Ange plats i modulernas sorteringsordning.', '6', '11' , now())");
    }
    
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
    
    function keys() {
      return array(
        'MODULE_PAYMENT_PAYER_MULTI_STATUS',
        'MODULE_PAYMENT_PAYER_ICON',
        'MODULE_PAYMENT_PAYER_MULTI_TESTMODE',
        'MODULE_PAYMENT_PAYER_MULTI_AGENT_ID',
        'MODULE_PAYMENT_PAYER_MULTI_KEY_1',
        'MODULE_PAYMENT_PAYER_MULTI_KEY_2',
        'MODULE_PAYMENT_PAYER_MULTI_CC_STATUS',
        'MODULE_PAYMENT_PAYER_MULTI_BANK_STATUS',
        'MODULE_PAYMENT_PAYER_MULTI_INVOICE_STATUS',
        'MODULE_PAYMENT_PAYER_MULTI_PHONE_STATUS',
        'MODULE_PAYMENT_PAYER_MULTI_ORDER_STATUS_ID',
        'MODULE_PAYMENT_PAYER_MULTI_SORT_ORDER'
      );
    }
    
  }

?>